routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\DepartmentController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});


Route::resource('employees', EmployeeController::class);

Route::get('employees/{employee}/confirm-delete', 'App\Http\Controllers\EmployeeController@confirmDelete')->name('employees.confirm-delete');

Route::resource('departments', DepartmentController::class);

Route::get('/dashboard', 'App\Http\Controllers\DashboardController@index')->name('dashboard');

app/Models/Department.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Department extends Model
{
    use HasFactory,SoftDeletes;

    protected $fillable = ['name'];

    public function employees()
    {
        return $this->hasMany(Employee::class);
    }
}

app/Http/Controllers/DepartmentController.php
<?php

namespace App\Http\Controllers;

use App\Models\Department;
use Illuminate\Http\Request;

class DepartmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $departments = Department::all();
        return view('departments.index', compact('departments'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('departments.create');        
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $department = new Department([
            'name' => $request->input('name'),
        ]);

        $department->save();

        return redirect()->route('departments.index')->with('success', 'Department added successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $departments = Department::findOrFail($id);

        return view('departments.show', compact('departments'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $departments = Department::findOrFail($id);
        return view('departments.edit', compact('departments'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $department = Department::findOrFail($id);

        $department->name = $request->input('name');
        $department->save();

        return redirect()->route('departments.show', $id)->with('success', 'Department details updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $department = Department::where('id',$id)->update(['deleted_at' => date('Y-m-d H:i:s')]);

        return redirect()->route('departments.index')->with('success', 'Department deleted successfully');
    }
}

resources/views/departments/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <h2 class="my-4">Add Department</h2>
            <form action="{{ route('departments.store') }}" method="POST">
                @csrf
                <div class="form-group">
                    <label for="name">Name</label>
                    <input type="text" class="form-control" id="name" name="name" required>
                </div>                
                <button type="submit" class="btn btn-primary">Add</button>
                <a href="{{ route('departments.index') }}" class="btn btn-success">Cancel</a>
            </form>
        </div>
    </div>
</div>
@endsection

resources/views/departments/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <h2 class="my-4">Edit Department</h2>
            <form action="{{ route('departments.update', $departments->id) }}" method="POST">
                @csrf
                @method('PUT')
                <div class="form-group">
                    <label for="name">Name</label>
                    <input type="text" class="form-control" id="name" name="name" value="{{ $departments->name }}" required>
                </div>                
                <button type="submit" class="btn btn-primary">Update</button>
                <a href="{{ route('departments.index') }}" class="btn btn-success">Cancel</a>                    

            </form>
        </div>
    </div>
</div>
@endsection

resources/views/departments/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <h2 class="my-4">Department List</h2>            
            <a href="{{ route('departments.create') }}" class="btn btn-success mb-4">Add Department</a>
            <table class="table table-bordered table-hover">
                <thead class="thead-dark">
                    <tr>
                        <th>Name</th>                        
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($departments as $department)
                        <tr>
                            <td>{{ $department->name }}</td>
                            <td>
                                <a href="{{ route('departments.show', $department->id) }}" class="btn btn-info btn-sm mr-2">View</a>
                                <a href="{{ route('departments.edit', $department->id) }}" class="btn btn-primary btn-sm mr-2">Edit</a>
                                <form action="{{ route('departments.destroy', $department->id) }}" method="POST" style="display: inline;">
                                    @csrf
                                    @method('DELETE')
                                    <button type="submit" class="btn btn-danger btn-sm" onclick="return confirm('Are you sure you want to delete this department?')">Delete</button>
                                </form>
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
    </div>
</div>
@endsection

resources/views/departments/show.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <h2 class="my-4">Department Details</h2>
            <div class="card">
                <div class="card-body">
                    <h5 class="card-title">{{ $departments->name }}</h5>
                    <a href="{{ route('departments.index') }}" class="btn btn-success mb-4">Return back</a>                    
                </div>
            </div>
        </div>
    </div>
</div>
@endsection